// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"context"
	"net/http"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/cisco-open/kubei/api/server/models"
)

// GetApplicationsHandlerFunc turns a function with the right signature into a get applications handler
type GetApplicationsHandlerFunc func(GetApplicationsParams) middleware.Responder

// Handle executing the request and returning a response
func (fn GetApplicationsHandlerFunc) Handle(params GetApplicationsParams) middleware.Responder {
	return fn(params)
}

// GetApplicationsHandler interface for that can handle valid get applications params
type GetApplicationsHandler interface {
	Handle(GetApplicationsParams) middleware.Responder
}

// NewGetApplications creates a new http.Handler for the get applications operation
func NewGetApplications(ctx *middleware.Context, handler GetApplicationsHandler) *GetApplications {
	return &GetApplications{Context: ctx, Handler: handler}
}

/* GetApplications swagger:route GET /applications getApplications

Get applications

*/
type GetApplications struct {
	Context *middleware.Context
	Handler GetApplicationsHandler
}

func (o *GetApplications) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewGetApplicationsParams()
	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetApplicationsOKBody get applications o k body
//
// swagger:model GetApplicationsOKBody
type GetApplicationsOKBody struct {

	// List of applications in the given filters and page. List length must be lower or equal to pageSize
	Items []*models.Application `json:"items"`

	// Total applications count under the given filters
	// Required: true
	Total *int64 `json:"total"`
}

// Validate validates this get applications o k body
func (o *GetApplicationsOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateItems(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateTotal(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetApplicationsOKBody) validateItems(formats strfmt.Registry) error {
	if swag.IsZero(o.Items) { // not required
		return nil
	}

	for i := 0; i < len(o.Items); i++ {
		if swag.IsZero(o.Items[i]) { // not required
			continue
		}

		if o.Items[i] != nil {
			if err := o.Items[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("getApplicationsOK" + "." + "items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (o *GetApplicationsOKBody) validateTotal(formats strfmt.Registry) error {

	if err := validate.Required("getApplicationsOK"+"."+"total", "body", o.Total); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this get applications o k body based on the context it is used
func (o *GetApplicationsOKBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := o.contextValidateItems(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetApplicationsOKBody) contextValidateItems(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(o.Items); i++ {

		if o.Items[i] != nil {
			if err := o.Items[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("getApplicationsOK" + "." + "items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetApplicationsOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetApplicationsOKBody) UnmarshalBinary(b []byte) error {
	var res GetApplicationsOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
